## Xalan-C++ API Documentation

### The Xalan C++ XSLT Processor Version 1.7

Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members

# XercesDocumentTypeWrapper Class Reference

`#include <XercesDocumentTypeWrapper.hpp>`

Inheritance diagram for XercesDocumentTypeWrapper

Collaboration diagram for XercesDocumentTypeWrapper:

List of all members.

## Public Methods

- XercesDocumentTypeWrapper ( const DOMDocumentType_Type* theXercesDOMDocumentType, const XercesWrapperNavigator& theNavigator)
- virtual ~XercesDocumentTypeWrapper ()
- virtual const XalanDOMString& getNodeName () const
    Gets the name of this node.
- virtual const XalanDOMString& getNodeValue () const
    Gets the value of this node, depending on its type.
- virtual NodeType getNodeType () const
    An enum value representing the type of the underlying object.
- virtual XalanNode* getParentNode () const
    Gets the parent of this node. More...
- virtual const XalanNodeList* getChildNodes () const
    Gets a `NodeList` that contains all children of this node. More...
- virtual XalanNode* getFirstChild () const
    Gets the first child of this node. More...
- virtual XalanNode* getLastChild () const
    Gets the last child of this node. More...
- virtual XalanNode* getPreviousSibling () const
    Gets the node immediately preceding this node. More...
- virtual XalanNode* getNextSibling () const
    Gets the node immediately following this node. More...
- virtual const XalanNamedNodeMap* getAttributes () const
    Gets a `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise.
- virtual XalanDocument* getOwnerDocument () const
    Gets the `DOMDocument` object associated with this node. More...

Cloning function.

- virtual XercesDocumentTypeWrapper* cloneNode (bool deep) const
    Returns a duplicate of this node. More...

Functions to modify the DOM Node.

- virtual XalanNode* insertBefore ( XalanNode* newChild, XalanNode* refChild)
    Inserts the node `newChild` before the existing child node `refChild`. More...
- virtual XalanNode* replaceChild ( XalanNode* newChild, XalanNode* oldChild)
    Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node. More...
- virtual XalanNode* removeChild (XalanNode* oldChild)
    Removes the child node indicated by `oldChild` from the list of children, and returns it. More...
- virtual XalanNode* appendChild (XalanNode* newChild)
    Adds the node `newChild` to the end of the list of children of this node. More...

Query functions.

- virtual bool hasChildNodes () const
    This is a convenience method to allow easy determination of whether a node has any children. More...

Set functions.

- virtual void setNodeValue (const XalanDOMString& nodeValue)
    Sets the value of the node. More...

Functions introduced in DOM Level 2.

- virtual void normalize ()
    Puts all `DOMText` nodes in the full depth of the sub-tree underneath this `DOMNode`, including attribute nodes, into a "normal" form where only markup (e.g., tags, comments, processing instructions, CDATA sections, and entity references) separates `DOMText` nodes, i.e., there are no adjacent `DOMText` nodes. More...
- virtual bool isSupported ( const XalanDOMString& feature, const XalanDOMString& version) const
    Tests whether the DOM implementation implements a specific feature and that feature is supported by this node. More...
- virtual const XalanDOMString& getNamespaceURI () const
    Get the namespace URI of this node, or `null` if it is unspecified. More...
- virtual const XalanDOMString& getPrefix () const
    Get the namespace prefix of this node, or `null` if it is unspecified.
- virtual const XalanDOMString& getLocalName () const
    Returns the local part of the qualified name of this node. More...
- virtual void setPrefix (const XalanDOMString& prefix)
    Set the namespace prefix of this node. More...
- virtual bool isIndexed () const
    Puts all `DOMText` nodes in the full depth of the sub-tree underneath this `DOMNode`, including attribute nodes, into a "normal" form where only markup (e.g., tags, comments, processing instructions, CDATA sections, and entity references) separates `DOMText` nodes, i.e., there are no adjacent `DOMText` nodes. More...
- virtual IndexType getIndex () const
    Puts all `DOMText` nodes in the full depth of the sub-tree underneath this `DOMNode`, including attribute nodes, into a "normal" form where only markup (e.g., tags, comments, processing instructions, CDATA sections, and entity references) separates `DOMText` nodes, i.e., there are no adjacent `DOMText` nodes. More...

Getter functions.

- virtual const XalanDOMString& getName () const
    The name of DTD; i.e., the name immediately following the `DOCTYPE` keyword in an XML source document.
- virtual const XalanNamedNodeMap* getEntities () const
    This function returns a `NamedNodeMap` containing the general entities, both external and internal, declared in the DTD. More...
- virtual const XalanNamedNodeMap* getNotations () const
    This function returns a named node map containing an entry for each notation declared in a document's DTD. More...

Functions introduced in DOM Level 2.

- virtual const XalanDOMString& getPublicId () const
    Get the public identifier of the external subset. More...
- virtual const XalanDOMString& getSystemId () const
    Get the system identifier of the external subset. More...
- virtual const XalanDOMString& getInternalSubset () const
    Get the internal subset as a string. More...
- const DOMDocumentType_Type* getXercesNode () const
    Get the Xerces node this instance represent. More...

## Constructor & Destructor Documentation

XercesDocumentTypeWrapper::XercesDocumentTypeWrapper ( | const DOMDocumentType_Type * theXercesDOMDocumentType,
| const XercesWrapperNavigator & theNavigator )

virtual XercesDocumentTypeWrapper::~XercesDocumentTypeWrapper ( | )`[virtual]`

## Member Function Documentation

XalanNode * XercesDocumentTypeWrapper::appendChild ( | XalanNode * newChild )`[virtual]`

Adds the node `newChild` to the end of the list of children of this node.

If the `newChild` is already in the tree, it is first removed.

Parameters:

  newChild | The node to add.If it is a `DocumentFragment` object, the entire contents of the document fragment are moved into the child list of this node

Returns:
  The node added.

Reimplemented from XalanDocumentType.

XercesDocumentTypeWrapper * XercesDocumentTypeWrapper::cloneNode ( | bool deep ) const`[virtual]`

Returns a duplicate of this node.

This function serves as a generic copy constructor for nodes.

The duplicate node has no parent ( `parentNode` returns `null`.).
Cloning an `Element` copies all attributes and their values, including those generated by the XML processor to represent defaulted attributes, but this method does not copy any text it contains unless it is a deep clone, since the text is contained in a child `Text` node. Cloning any other type of node simply returns a copy of this node.

Parameters:

  deep | If `true`, recursively clone the subtree under the specified node; if `false`, clone only the node itself (and its attributes, if it is an `Element`).

Returns:
  The duplicate node.

Reimplemented from XalanDocumentType.

const XalanNamedNodeMap * XercesDocumentTypeWrapper::getAttributes ( | ) const`[virtual]`

Gets a `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise.

Reimplemented from XalanDocumentType.

const XalanNodeList * XercesDocumentTypeWrapper::getChildNodes ( | ) const`[virtual]`

Gets a `NodeList` that contains all children of this node.

If there are no children, this is a `NodeList` containing no nodes. The content of the returned `NodeList` is "live" in the sense that, for instance, changes to the children of the node object that it was created from are immediately reflected in the nodes returned by the `NodeList` accessors; it is not a static snapshot of the content of the node. This is true for every `NodeList`, including the ones returned by the `getElementsByTagName` method.

Reimplemented from XalanDocumentType.

const XalanNamedNodeMap * XercesDocumentTypeWrapper::getEntities ( | ) const`[virtual]`

This function returns a `NamedNodeMap` containing the general entities, both external and internal, declared in the DTD.

Parameter entities are not contained. Duplicates are discarded.

Reimplemented from XalanDocumentType.

XalanNode * XercesDocumentTypeWrapper::getFirstChild ( | ) const`[virtual]`

Gets the first child of this node.

If there is no such node, this returns `null`.

Reimplemented from XalanDocumentType.

IndexType XercesDocumentTypeWrapper::getIndex ( | ) const`[virtual]`

Puts all `DOMText` nodes in the full depth of the sub-tree underneath this `DOMNode`, including attribute nodes, into a "normal" form where only markup (e.g., tags, comments, processing instructions, CDATA sections, and entity references) separates `DOMText` nodes, i.e., there are no adjacent `DOMText` nodes.

This can be used to ensure that the DOM view of a document is the same as if it were saved and re-loaded, and is useful when operations (such as XPointer lookups) that depend on a particular document tree structure are to be used.

Note: In cases where the document contains `DOMCDATASections`, the normalize operation alone may not be sufficient, since XPointers do not differentiate between `DOMText` nodes and `DOMCDATASection` nodes.

Reimplemented from XalanDocumentType.

const XalanDOMString & XercesDocumentTypeWrapper::getInternalSubset ( | ) const`[virtual]`

Get the internal subset as a string.

Returns:
  The internal subset as a string.

Reimplemented from XalanDocumentType.

XalanNode * XercesDocumentTypeWrapper::getLastChild ( | ) const`[virtual]`

Gets the last child of this node.

If there is no such node, this returns `null`.

Reimplemented from XalanDocumentType.

const XalanDOMString & XercesDocumentTypeWrapper::getLocalName ( | ) const`[virtual]`

Returns the local part of the qualified name of this node.

For nodes created with a DOM Level 1 method, such as `createElement` from the `DOMDocument` interface, it is null.

Reimplemented from XalanDocumentType.

const XalanDOMString & XercesDocumentTypeWrapper::getName ( | ) const`[virtual]`

The name of DTD; i.e., the name immediately following the `DOCTYPE` keyword in an XML source document.

Reimplemented from XalanDocumentType.

const XalanDOMString & XercesDocumentTypeWrapper::getNamespaceURI ( | ) const`[virtual]`

Get the namespace URI of this node, or `null` if it is unspecified.

This is not a computed value that is the result of a namespace lookup based on an examination of the namespace declarations in scope. It is merely the namespace URI given at creation time.

For nodes of any type other than `ELEMENT_NODE` and `ATTRIBUTE_NODE` and nodes created with a DOM Level 1 method, such as `createElement` from the `Document` interface, this is always `null`.

Reimplemented from XalanDocumentType.

XalanNode * XercesDocumentTypeWrapper::getNextSibling ( | ) const`[virtual]`

Gets the node immediately following this node.

If there is no such node, this returns `null`.

Reimplemented from XalanDocumentType.

virtual const XalanDOMString& XercesDocumentTypeWrapper::getNodeName ( | ) const`[virtual]`

Gets the name of this node.

Reimplemented from XalanDocumentType.

NodeType XercesDocumentTypeWrapper::getNodeType ( | ) const`[virtual]`

An enum value representing the type of the underlying object.

Reimplemented from XalanDocumentType.

const XalanDOMString & XercesDocumentTypeWrapper::getNodeValue ( | ) const`[virtual]`

Gets the value of this node, depending on its type.

Reimplemented from XalanDocumentType.

const XalanNamedNodeMap * XercesDocumentTypeWrapper::getNotations ( | ) const`[virtual]`

This function returns a named node map containing an entry for each notation declared in a document's DTD.

Duplicates are discarded.

Reimplemented from XalanDocumentType.

XalanDocument * XercesDocumentTypeWrapper::getOwnerDocument ( | ) const`[virtual]`

Gets the `DOMDocument` object associated with this node.

This is also the `DOMDocument` object used to create new nodes. When this node is a `DOMDocument` or a `DOMDocumentType` which is not used with any `DOMDocument` yet, this is `null`.

Reimplemented from XalanDocumentType.

XalanNode * XercesDocumentTypeWrapper::getParentNode ( | ) const`[virtual]`

Gets the parent of this node.

All nodes, except `Document`, `DocumentFragment`, and `Attr` may have a parent. However, if a node has just been created and not yet added to the tree, or if it has been removed from the tree, a `null` DOMNode is returned.

Reimplemented from XalanDocumentType.

const XalanDOMString & XercesDocumentTypeWrapper::getPrefix ( | ) const`[virtual]`

Get the namespace prefix of this node, or `null` if it is unspecified.

Reimplemented from XalanDocumentType.

XalanNode * XercesDocumentTypeWrapper::getPreviousSibling ( | ) const`[virtual]`

Gets the node immediately preceding this node.

If there is no such node, this returns `null`.

Reimplemented from XalanDocumentType.

const XalanDOMString & XercesDocumentTypeWrapper::getPublicId ( | ) const`[virtual]`

Get the public identifier of the external subset.

Returns:
  The public identifier of the external subset.

Reimplemented from XalanDocumentType.

const XalanDOMString & XercesDocumentTypeWrapper::getSystemId ( | ) const`[virtual]`

Get the system identifier of the external subset.

Returns:
  The system identifier of the external subset.

Reimplemented from XalanDocumentType.

const DOMDocumentType_Type * XercesDocumentTypeWrapper::getXercesNode ( | ) const`[]`

Get the Xerces node this instance represent.

Returns:
  The Xerces node

bool XercesDocumentTypeWrapper::hasChildNodes ( | ) const`[virtual]`

This is a convenience method to allow easy determination of whether a node has any children.

Returns:
  `true` if the node has any children, `false` if the node has no children.

Reimplemented from XalanDocumentType.

XalanNode * XercesDocumentTypeWrapper::insertBefore ( | XalanNode * newChild,
| XalanNode * refChild )`[virtual]`

Inserts the node `newChild` before the existing child node `refChild`.

If `refChild` is `null`, insert `newChild` at the end of the list of children.
If `newChild` is a `DocumentFragment` object, all of its children are inserted, in the same order, before `refChild`. If the `newChild` is already in the tree, it is first removed. Note that a `DOMNode` that has never been assigned to refer to an actual node is == null.

Parameters:

  newChild | The node to insert.
  refChild | The reference node, i.e., the node before which the new node must be inserted.

Returns:
  The node being inserted.

Reimplemented from XalanDocumentType.

bool XercesDocumentTypeWrapper::isIndexed ( | ) const`[virtual]`

Puts all `DOMText` nodes in the full depth of the sub-tree underneath this `DOMNode`, including attribute nodes, into a "normal" form where only markup (e.g., tags, comments, processing instructions, CDATA sections, and entity references) separates `DOMText` nodes, i.e., there are no adjacent `DOMText` nodes.

This can be used to ensure that the DOM view of a document is the same as if it were saved and re-loaded, and is useful when operations (such as XPointer lookups) that depend on a particular document tree structure are to be used.

Note: In cases where the document contains `DOMCDATASections`, the normalize operation alone may not be sufficient, since XPointers do not differentiate between `DOMText` nodes and `DOMCDATASection` nodes.

Reimplemented from XalanDocumentType.

bool XercesDocumentTypeWrapper::isSupported ( | const XalanDOMString & feature,
| const XalanDOMString & version ) const`[virtual]`

Tests whether the DOM implementation implements a specific feature and that feature is supported by this node.

Parameters:

  feature | The string of the feature to test. This is the same name as what can be passed to the method `hasFeature` on `DOMImplementation`.
  version | This is the version number of the feature to test. In Level 2, version 1, this is the string "2.0". If the version is not specified, supporting any version of the feature will cause the method to return `true`.

Returns:
  Returns `true` if the specified feature is supported on this node, `false` otherwise.

Reimplemented from XalanDocumentType.

void XercesDocumentTypeWrapper::normalize ( | )`[virtual]`

Puts all `DOMText` nodes in the full depth of the sub-tree underneath this `DOMNode`, including attribute nodes, into a "normal" form where only markup (e.g., tags, comments, processing instructions, CDATA sections, and entity references) separates `DOMText` nodes, i.e., there are no adjacent `DOMText` nodes.

This can be used to ensure that the DOM view of a document is the same as if it were saved and re-loaded, and is useful when operations (such as XPointer lookups) that depend on a particular document tree structure are to be used.

Note: In cases where the document contains `DOMCDATASections`, the normalize operation alone may not be sufficient, since XPointers do not differentiate between `DOMText` nodes and `DOMCDATASection` nodes.

Reimplemented from XalanDocumentType.

XalanNode * XercesDocumentTypeWrapper::removeChild ( | XalanNode * oldChild )`[virtual]`

Removes the child node indicated by `oldChild` from the list of children, and returns it.

Parameters:

  oldChild | The node being removed.

Returns:
  The node removed.

Reimplemented from XalanDocumentType.

XalanNode * XercesDocumentTypeWrapper::replaceChild ( | XalanNode * newChild,
| XalanNode * oldChild )`[virtual]`

Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node.

If `newChild` is a `DOMDocumentFragment` object, `oldChild` is replaced by all of the `DOMDocumentFragment` children, which are inserted in the same order.

If the `newChild` is already in the tree, it is first removed.

Parameters:

  newChild | The new node to put in the child list.
  oldChild | The node being replaced in the list.

Returns:
  The node replaced.

Reimplemented from XalanDocumentType.

void XercesDocumentTypeWrapper::setNodeValue ( | const XalanDOMString & nodeValue )`[virtual]`

Sets the value of the node.

Any node which can have a nodeValue (

See also:
  getNodeValue()) will also accept requests to set it to a string. The exact response to this varies from node to node -- Attribute, for example, stores its values in its children and has to replace them with a new Text holding the replacement value.

For most types of Node, value is null and attempting to set it will throw DOMException(NO_MODIFICATION_ALLOWED_ERR). This will also be thrown if the node is read-only.

Reimplemented from XalanDocumentType.

void XercesDocumentTypeWrapper::setPrefix ( | const XalanDOMString & prefix )`[virtual]`

Set the namespace prefix of this node.

Note that setting this attribute, when permitted, changes the `nodeName` attribute, which holds the qualified name, as well as the `tagName` and `name` attributes of the `DOMElement` and `DOMAttr` interfaces, when applicable.

Note also that changing the prefix of an attribute, that is known to have a default value, does not make a new attribute with the default value and the original prefix appear, since the `namespaceURI` and `localName` do not change.

Parameters:

  prefix | The prefix of this node.

Exceptions:

  DOMException | INVALID_CHARACTER_ERR: Raised if the specified prefix contains an illegal character. NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly. NAMESPACE_ERR: Raised if the specified `prefix` is malformed, if the specified prefix is "xml" and the `namespaceURI` of this node is different from "http://www.w3.org/XML/1998/namespace", if specified prefix is "xmlns" and the `namespaceURI` is neither `null` nor an empty string, or if the `localName` is `null`.

Reimplemented from XalanDocumentType.

The documentation for this class was generated from the following file:

- XercesDocumentTypeWrapper.hpp

Interpreting class diagrams

Doxygen and GraphViz are used to generate this API documentation from the Xalan-C header files.

Xalan-C++ XSLT Processor Version 1.7 Copyright © 1999-2004 The Apache Software Foundation. All Rights Reserved.